diff --git a/src/backend/optimizer/path/allpaths.c b/src/backend/optimizer/path/allpaths.c
index 2e4b670..06fc90d 100644
--- a/src/backend/optimizer/path/allpaths.c
+++ b/src/backend/optimizer/path/allpaths.c
@@ -999,21 +999,59 @@ set_append_rel_size(PlannerInfo *root, RelOptInfo *rel,
 		if (rel->has_eclass_joins || has_useful_pathkeys(root, rel))
 			add_child_rel_equivalences(root, appinfo, rel, childrel);
 		childrel->has_eclass_joins = rel->has_eclass_joins;
 
 		/*
 		 * Note: we could compute appropriate attr_needed data for the child's
 		 * variables, by transforming the parent's attr_needed through the
 		 * translated_vars mapping.  However, currently there's no need
 		 * because attr_needed is only examined for base relations not
 		 * otherrels.  So we just leave the child's attr_needed empty.
+		 * For a partitioned tables, individual partitions can participate in
+		 * the pair-wise joins. We need attr_needed data for building pair-wise
+		 * join relations. Partitions should have same layout as the parent
+		 * table and hence should not need any translation, but we still use
+		 * the translated_vars to keep the code in sync with the inheritance
+		 * code.
 		 */
+		if (rel->part_info)
+		{
+			AttrNumber attno;
+			for (attno = rel->min_attr; attno <= rel->max_attr; attno++)
+			{
+				int	index = attno - rel->min_attr;
+				Relids	attr_needed = bms_copy(rel->attr_needed[index]);
+
+				/*
+				 * System attributes do not need translation. In such a case,
+				 * the attribute numbers of the parent and the child should
+				 * start from the same minimum attribute.
+				 */
+				if (attno <= 0)
+				{
+					Assert(rel->min_attr == childrel->min_attr);
+					childrel->attr_needed[index] = attr_needed;
+				}
+				else
+				{
+					Var *var = list_nth(appinfo->translated_vars,
+										attno - 1);
+					int child_index;
+
+					/* Parent Var translates to child Var. */
+					Assert(IsA(var, Var));
+
+					child_index = var->varattno - childrel->min_attr;
+					childrel->attr_needed[child_index] = attr_needed;
+				}
+			}
+		}
 
 		/*
 		 * Compute the child's size.
 		 */
 		set_rel_size(root, childrel, childRTindex, childRTE);
 
 		/*
 		 * It is possible that constraint exclusion detected a contradiction
 		 * within a child subquery, even though we didn't prove one above. If
 		 * so, we can skip this child.
diff --git a/src/backend/optimizer/path/costsize.c b/src/backend/optimizer/path/costsize.c
index 8c1dccc..3ab6a9d 100644
--- a/src/backend/optimizer/path/costsize.c
+++ b/src/backend/optimizer/path/costsize.c
@@ -119,20 +119,21 @@ bool		enable_seqscan = true;
 bool		enable_indexscan = true;
 bool		enable_indexonlyscan = true;
 bool		enable_bitmapscan = true;
 bool		enable_tidscan = true;
 bool		enable_sort = true;
 bool		enable_hashagg = true;
 bool		enable_nestloop = true;
 bool		enable_material = true;
 bool		enable_mergejoin = true;
 bool		enable_hashjoin = true;
+bool		enable_partition_wise_join = true;
 
 typedef struct
 {
 	PlannerInfo *root;
 	QualCost	total;
 } cost_qual_eval_context;
 
 static List *extract_nonindex_conditions(List *qual_clauses, List *indexquals);
 static MergeScanSelCache *cached_scansel(PlannerInfo *root,
 			   RestrictInfo *rinfo,
diff --git a/src/backend/optimizer/path/joinrels.c b/src/backend/optimizer/path/joinrels.c
index 01d4fea..e485e01 100644
--- a/src/backend/optimizer/path/joinrels.c
+++ b/src/backend/optimizer/path/joinrels.c
@@ -7,38 +7,56 @@
  * Portions Copyright (c) 1994, Regents of the University of California
  *
  *
  * IDENTIFICATION
  *	  src/backend/optimizer/path/joinrels.c
  *
  *-------------------------------------------------------------------------
  */
 #include "postgres.h"
 
+#include "optimizer/clauses.h"
 #include "optimizer/joininfo.h"
 #include "optimizer/pathnode.h"
 #include "optimizer/paths.h"
+#include "optimizer/cost.h"
 #include "utils/memutils.h"
 
 
 static void make_rels_by_clause_joins(PlannerInfo *root,
 						  RelOptInfo *old_rel,
 						  ListCell *other_rels);
 static void make_rels_by_clauseless_joins(PlannerInfo *root,
 							  RelOptInfo *old_rel,
 							  ListCell *other_rels);
 static bool has_join_restriction(PlannerInfo *root, RelOptInfo *rel);
 static bool has_legal_joinclause(PlannerInfo *root, RelOptInfo *rel);
 static bool is_dummy_rel(RelOptInfo *rel);
 static void mark_dummy_rel(RelOptInfo *rel);
 static bool restriction_is_constant_false(List *restrictlist,
 							  bool only_pushed_down);
+static bool have_partkey_equi_join(RelOptInfo *rel1, RelOptInfo *rel2,
+						   SpecialJoinInfo *sjinfo, List *restrictlist);
+static PartitionOptInfo *build_joinrel_part_info(RelOptInfo *rel1,
+							   RelOptInfo *rel2, SpecialJoinInfo *sjinfo,
+							   List *restrictlist);
+static void add_append_paths_to_joinrel(RelOptInfo *joinrel);
+static void match_expr_to_partition_keys(RestrictInfo *rinfo, Expr *expr,
+						  RelOptInfo *rel, List **pkclauses);
+static bool partkey_types_match(PartitionOptInfo *part_info1,
+					PartitionOptInfo *part_info2);
+static bool have_same_partition_lists(PartitionOptInfo *part_info1,
+					  PartitionOptInfo *part_info2);
+static bool have_same_partition_bounds(PartitionOptInfo *part_info1,
+					  PartitionOptInfo *part_info2);
+static bool compare_partition_bounds(PartitionOptInfo *part_info,
+					PartitionRangeBound *bound1, PartitionRangeBound *bound2);
 
 
 /*
  * join_search_one_level
  *	  Consider ways to produce join relations containing exactly 'level'
  *	  jointree items.  (This is one step of the dynamic-programming method
  *	  embodied in standard_join_search.)  Join rel nodes for each feasible
  *	  combination of lower-level rels are created and returned in a list.
  *	  Implementation paths are created for each such joinrel, too.
  *
@@ -652,20 +670,21 @@ join_is_legal(PlannerInfo *root, RelOptInfo *rel1, RelOptInfo *rel2,
  */
 RelOptInfo *
 make_join_rel(PlannerInfo *root, RelOptInfo *rel1, RelOptInfo *rel2)
 {
 	Relids		joinrelids;
 	SpecialJoinInfo *sjinfo;
 	bool		reversed;
 	SpecialJoinInfo sjinfo_data;
 	RelOptInfo *joinrel;
 	List	   *restrictlist;
+	PartitionOptInfo	*part_info;
 
 	/* We should never try to join two overlapping sets of rels. */
 	Assert(!bms_overlap(rel1->relids, rel2->relids));
 
 	/* Construct Relids set that identifies the joinrel. */
 	joinrelids = bms_union(rel1->relids, rel2->relids);
 
 	/* Check validity and determine join type. */
 	if (!join_is_legal(root, rel1, rel2, joinrelids,
 					   &sjinfo, &reversed))
@@ -862,25 +881,372 @@ make_join_rel(PlannerInfo *root, RelOptInfo *rel1, RelOptInfo *rel2)
 			add_paths_to_joinrel(root, joinrel, rel1, rel2,
 								 JOIN_ANTI, sjinfo,
 								 restrictlist);
 			break;
 		default:
 			/* other values not expected here */
 			elog(ERROR, "unrecognized join type: %d", (int) sjinfo->jointype);
 			break;
 	}
 
+	/*
+	 * If both the relations are partitioned in the same way, and there is an
+	 * equi-join clause on partition key, try joining the partitions. Store the
+	 * partitioning scheme in joinrel for further joins.
+	 */
+	part_info = build_joinrel_part_info(rel1, rel2, sjinfo, restrictlist);
+	joinrel->part_info = part_info;
+	if (part_info)
+	{
+		PartitionOptInfo *part_info1 = rel1->part_info;
+		PartitionOptInfo *part_info2 = rel2->part_info;
+		int		nparts = part_info->nparts;
+		int		cnt_parts;
+		StringInfo	rel1_desc = makeStringInfo();
+		StringInfo	rel2_desc = makeStringInfo();
+
+		/* TODO: remove this notice when finalising the patch. */
+		outBitmapset(rel1_desc, rel1->relids);
+		outBitmapset(rel2_desc, rel2->relids);
+		elog(NOTICE, "join between relations %s and %s is considered for partition-wise join.",
+			 rel1_desc->data, rel2_desc->data);
+
+		/* Create join relations for the partition relations. */
+		for (cnt_parts = 0; cnt_parts < nparts; cnt_parts++)
+		{
+			RelOptInfo	*part_join_rel;
+
+			/*
+			 * TODO: make_join_rel can return NULL if the join is illegal. This
+			 * should not happen since the join between parents is deemed
+			 * legal.
+			 */
+			part_join_rel = make_join_rel(root,
+										  part_info1->part_rels[cnt_parts],
+										  part_info2->part_rels[cnt_parts]);
+			part_info->part_rels[cnt_parts] = part_join_rel;
+		}
+
+		/* Add append paths for pair-wise joins. */
+		add_append_paths_to_joinrel(joinrel);
+	}
+	/* TODO: remove this notice printing code while finalising the patch. */
+	else if (!IS_OTHER_REL(rel1->reloptkind) && !IS_OTHER_REL(rel2->reloptkind))
+	{
+		StringInfo	rel1_desc = makeStringInfo();
+		StringInfo	rel2_desc = makeStringInfo();
+
+		/* TODO: remove this notice when finalising the patch. */
+		outBitmapset(rel1_desc, rel1->relids);
+		outBitmapset(rel2_desc, rel2->relids);
+		elog(NOTICE, "join between relations %s and %s is NOT considered for partition-wise join.",
+			 rel1_desc->data, rel2_desc->data);
+	}
+
 	bms_free(joinrelids);
 
 	return joinrel;
 }
 
+/*
+ * build_joinrel_part_info
+ *
+ * Given partition description of two joining relations, construct partition
+ * description for join between those relations. If we can execute
+ * partition-wise join the resultant join is partitioned in the same way as the
+ * joining relations. Otherwise, it is not partitioned and in such case the
+ * function returns NULL.
+ *
+ * TODO find the right place for this function.
+ *
+ * TODO:
+ * This function and
+ * build_partition_info() should be named consistently e.g.
+ * build_joinrel_partition_info and build_simplerel_partition_info or
+ * build_baserel_partition_info resp.
+ */
+static PartitionOptInfo *
+build_joinrel_part_info(RelOptInfo *rel1, RelOptInfo *rel2,
+						SpecialJoinInfo *sjinfo, List *restrictlist)
+{
+	PartitionOptInfo	*part_info;
+	PartitionOptInfo	*part_info1 = rel1->part_info;
+	PartitionOptInfo	*part_info2 = rel2->part_info;
+	int		cnt_pks;
+	int		num_pks;
+
+	/* Do nothing, if user doesn't want to try partition-wise join. */
+	if (!enable_partition_wise_join)
+		return NULL;
+
+	/*
+	 * If number of partitions, number of partition keys and partitioning
+	 * strategy of the joining relations do not match, we can not apply
+	 * partition-wise join.
+	 *
+	 * TODO: it should be possible to push an inner join down even if the number of
+	 * partitions differ but the common partitions match. In such a case pushing
+	 * down outer joins would be tricky, but still doable using empty relation
+	 * for non-existing partition.
+	 */
+	if (!part_info1 || !part_info2 ||
+		part_info1->nparts != part_info2->nparts ||
+		part_info1->strategy != part_info2->strategy ||
+		part_info1->partnatts != part_info2->partnatts)
+		return NULL;
+
+	/*
+	 * Partition-wise join can not be applied if datatypes and collations of
+	 * the partition keys do not match.
+	 */
+	if (!partkey_types_match(part_info1, part_info2))
+		return NULL;
+
+	/*
+	 * Partition-wise join can not be applied if the partition bounds or lists
+	 * of joining relations do not match.
+	 */
+	switch (part_info1->strategy)
+	{
+		case PARTITION_STRAT_LIST:
+			if (!have_same_partition_lists(part_info1, part_info2))
+				return NULL;
+			break;
+
+		case PARTITION_STRAT_RANGE:
+			if (!have_same_partition_bounds(part_info1, part_info2))
+				return NULL;
+			break;
+
+		default:
+			/* Unknown partition strategy. */
+			return NULL;
+	}
+
+	/*
+	 * Partition-wise join can not be applied if there is no equi-join
+	 * condition between partition keys.
+	 */
+	if (!have_partkey_equi_join(rel1, rel2, sjinfo, restrictlist))
+		return NULL;
+
+	/* The join is partitioned the similar to the joining relations. */
+	part_info = makeNode(PartitionOptInfo);
+
+	/* Information related to the partititions. */
+	part_info->nparts = part_info1->nparts;
+	/* Allocate space for partition RelOptInfos, which will be filled later. */
+	part_info->part_rels = (RelOptInfo **) palloc(sizeof(RelOptInfo *) *
+												  part_info->nparts);
+	part_info->lists = part_info1->lists;
+	part_info->rangelowers = part_info1->rangelowers;
+	part_info->rangeuppers = part_info1->rangeuppers;
+
+	/* Information related to partition keys. */
+	part_info->strategy = part_info1->strategy;
+	part_info->partnatts = part_info1->partnatts;
+	part_info->partopfamily = part_info1->partopfamily;
+	part_info->partopcintype = part_info1->partopcintype;
+	part_info->partsupfunc = part_info1->partsupfunc;
+	part_info->tcinfo = part_info1->tcinfo;
+	num_pks = part_info->partnatts;
+	part_info->partexprs = (List **) palloc0(sizeof(List *) * num_pks);
+	for (cnt_pks = 0; cnt_pks < num_pks; cnt_pks++)
+	{
+		List *pkexpr = list_copy(part_info1->partexprs[cnt_pks]);
+
+		pkexpr = list_concat(pkexpr,
+							 list_copy(part_info2->partexprs[cnt_pks]));
+		part_info->partexprs[cnt_pks] = pkexpr;
+	}
+
+	return part_info;
+}
+
+/*
+ * Returns true if the given relations have equi-join clauses on all the
+ * corresponding partition keys.
+ */
+static bool
+have_partkey_equi_join(RelOptInfo *rel1, RelOptInfo *rel2,
+					 SpecialJoinInfo *sjinfo, List *restrictlist)
+{
+	PartitionOptInfo	*part_info1 = rel1->part_info;
+	PartitionOptInfo	*part_info2 = rel2->part_info;
+	ListCell	*lc;
+	List	   **pkclauses1;
+	List	   **pkclauses2;
+	int		cnt_pks;
+	int		num_pks;
+
+	Assert(part_info1->partnatts == part_info2->partnatts);
+	num_pks = part_info1->partnatts;
+	pkclauses1 = (List **) palloc0(sizeof(List *) * num_pks);
+	pkclauses2 = (List **) palloc0(sizeof(List *) * num_pks);
+
+	foreach (lc, restrictlist)
+	{
+		RestrictInfo *rinfo = lfirst(lc);
+		OpExpr		 *opexpr;
+		Expr		 *expr1;
+		Expr		 *expr2;
+
+		/* If processing an outer join, only use its own join clauses. */
+		if (IS_OUTER_JOIN(sjinfo->jointype) && rinfo->is_pushed_down)
+			continue;
+
+		/* Skip non-equi-join clauses. */
+		if (!rinfo->can_join ||
+			rinfo->hashjoinoperator == InvalidOid ||
+			!rinfo->mergeopfamilies)
+			continue;
+
+		opexpr = (OpExpr *) rinfo->clause;
+		Assert(is_opclause(opexpr));
+
+		/*
+		 * If clause of form rel1_expr op rel2_expr OR rel2_expr op rel1_expr,
+		 * match the operands to the relations. Otherwise, the clause is
+		 * not an equi-join between partition keys of joining relations.
+		 */
+		if (bms_is_subset(rinfo->left_relids, rel1->relids) &&
+			bms_is_subset(rinfo->right_relids, rel2->relids))
+		{
+			expr1 = linitial(opexpr->args);
+			expr2 = lsecond(opexpr->args);
+		}
+		else if (bms_is_subset(rinfo->left_relids, rel2->relids) &&
+				 bms_is_subset(rinfo->right_relids, rel1->relids))
+		{
+			expr1 = lsecond(opexpr->args);
+			expr2 = linitial(opexpr->args);
+		}
+		else
+			continue;
+
+		/* Associate matching clauses with partition keys. */
+		match_expr_to_partition_keys(rinfo, expr1, rel1, pkclauses1);
+		match_expr_to_partition_keys(rinfo, expr2, rel2, pkclauses2);
+	}
+
+	/*
+	 * If every pair of partition key from either of the joining relation has
+	 * at least one equi-join clause associated with it, we have an equi-join
+	 * between all corresponding partition keys.
+	 */
+	for (cnt_pks = 0; cnt_pks < num_pks; cnt_pks++)
+	{
+		List *li = list_intersection(pkclauses1[cnt_pks],
+									 pkclauses2[cnt_pks]);
+		if (!li)
+			return false;
+
+		/* We don't need the actual intersection list. */
+		list_free(li);
+	}
+	return true;
+}
+
+/*
+ * match_expr_to_partition_keys
+ *
+ * Find the partition key which is same as the given expression. If we are able
+ * to find one, add the clause to the list of clauses associated with that
+ * partition key. It is assumed that the given expression is part of the given
+ * clause.
+ *
+ * TODO: Since a given partition key appears only once in the partition by
+ * clause, it should be possible to return the position of the matching
+ * partition key and let the caller handle association of clauses. If we do so,
+ * we will be able to discard the clauses associated with different partition
+ * keys and just remember whether a pair of partition keys has associated
+ * clause or not (rather than remembering the whole list of clauses).
+ */
+static void
+match_expr_to_partition_keys(RestrictInfo *rinfo, Expr *expr, RelOptInfo *rel,
+							 List **pkclauses)
+{
+	PartitionOptInfo *part_info = rel->part_info;
+	int		cnt_pks;
+
+	/*
+	 * Remove the relabel decoration. We can assume that there is at most one
+	 * RelabelType node; eval_const_expressions() will have simplied if more
+	 * than one.
+	 */
+	if (IsA(expr, RelabelType))
+		expr = (Expr *) ((RelabelType *) expr)->arg;
+
+	for (cnt_pks = 0; cnt_pks < part_info->partnatts; cnt_pks++)
+	{
+		List	 *pkexprs = part_info->partexprs[cnt_pks];
+		ListCell *lc;
+
+		foreach(lc, pkexprs)
+		{
+			Expr *pkexpr = lfirst(lc);
+			if (equal(pkexpr, expr))
+			{
+				pkclauses[cnt_pks] = list_append_unique(pkclauses[cnt_pks],
+														rinfo);
+				break;
+			}
+		}
+	}
+}
+
+/*
+ * Add append paths for the join relation.
+ *
+ * Like set_append_rel_pathlist, this function considers pair-wise partition
+ * join paths with parameterization and pathkeys.
+ *
+ * TODO: right now the function just picks up the cheapest path from each of
+ * the partitions and creates an append path with those.
+ *
+ * TODO: may be we should consider splitting set_append_rel_pathlist() so that
+ * it can be used for both inheritance and partitioning.
+ */
+static void
+add_append_paths_to_joinrel(RelOptInfo *joinrel)
+{
+	PartitionOptInfo	*part_info = joinrel->part_info;
+	RelOptInfo **part_rels = part_info->part_rels;
+	int		nparts;
+	int		cnt_parts;
+	List   *part_paths = NIL;
+
+	Assert(part_info);
+
+	nparts = part_info->nparts;
+
+	for (cnt_parts = 0; cnt_parts < nparts; cnt_parts++)
+	{
+		RelOptInfo *part_rel = part_rels[cnt_parts];
+
+		/* Find the cheapest path for partition relation. */
+		set_cheapest(part_rel);
+
+		/* We don't expect any parameterization here. */
+		Assert(!part_rel->cheapest_total_path->param_info);
+
+		/*
+		 * Instead of lappend, we should use accumulate_append_subpath() to
+		 * pull up the paths in underlying append.
+		 */
+		part_paths = lappend(part_paths, part_rel->cheapest_total_path);
+	}
+
+	add_path(joinrel, (Path *) create_append_path(joinrel, part_paths, NULL,
+												  0));
+	return;
+}
 
 /*
  * have_join_order_restriction
  *		Detect whether the two relations should be joined to satisfy
  *		a join-order restriction arising from special or lateral joins.
  *
  * In practice this is always used with have_relevant_joinclause(), and so
  * could be merged with that function, but it seems clearer to separate the
  * two concerns.  We need this test because there are degenerate cases where
  * a clauseless join must be performed to satisfy join-order restrictions.
@@ -1242,10 +1608,180 @@ restriction_is_constant_false(List *restrictlist, bool only_pushed_down)
 
 			/* constant NULL is as good as constant FALSE for our purposes */
 			if (con->constisnull)
 				return true;
 			if (!DatumGetBool(con->constvalue))
 				return true;
 		}
 	}
 	return false;
 }
+
+/*
+ * have_same_partition_lists
+ *
+ * For given list partitioned relations, return true if lists for all the
+ * partitions of both the relations match. Return false otherwise.
+ */
+static bool
+have_same_partition_lists(PartitionOptInfo *part_info1,
+						  PartitionOptInfo *part_info2)
+{
+	int		cnt_parts;
+
+	Assert(part_info1->strategy == PARTITION_STRAT_LIST &&
+		   part_info2->strategy == PARTITION_STRAT_LIST);
+
+	Assert(part_info1->nparts == part_info2->nparts);
+
+	/* List partition has only one partition key. */
+	Assert(part_info1->partnatts == 1 && part_info2->partnatts == 1);
+
+	for (cnt_parts = 0; cnt_parts < part_info1->nparts; cnt_parts++)
+	{
+		PartitionListBound *list1 = part_info1->lists[cnt_parts];
+		PartitionListBound *list2 = part_info2->lists[cnt_parts];
+		int		cnt;
+
+		/*
+		 * If number of items in the lists do not match or the one of the lists
+		 * contains NULL value and other doesn't, lists do not match.
+		 *
+		 * TODO: This condition can be relaxed to accomodate subset of items,
+		 * but probably not in the first cut.
+		 */
+		if (list1->contains_null != list2->contains_null ||
+			list1->nvalues != list2->nvalues)
+			return false;
+
+		/* Compare actual values in the list. */
+		for (cnt = 0; cnt < list1->nvalues; cnt++)
+		{
+			Datum	cmpval;
+
+			cmpval = FunctionCall2Coll(&part_info1->partsupfunc[0],
+									   part_info1->tcinfo->typcoll[0],
+									   list1->values[cnt],
+									   list2->values[cnt]);
+			if (DatumGetInt32(cmpval))
+				return false;
+		}
+	}
+
+	/* Ok, everything matches, return true. */
+	return true;
+}
+
+/*
+ * have_same_partition_bounds
+ *
+ * For given partitioned relations, return true if the bounds of all the
+ * partitions of the both the relations match. Return false otherwise.
+ */
+static bool
+have_same_partition_bounds(PartitionOptInfo *part_info1,
+						   PartitionOptInfo *part_info2)
+{
+	int		cnt_parts;
+	Assert(part_info1->strategy == PARTITION_STRAT_RANGE &&
+		   part_info2->strategy == PARTITION_STRAT_RANGE);
+
+	Assert(part_info1->nparts == part_info2->nparts);
+
+	for (cnt_parts = 0; cnt_parts < part_info1->nparts; cnt_parts++)
+	{
+		PartitionRangeBound *lower1 = part_info1->rangelowers[cnt_parts];
+		PartitionRangeBound *lower2 = part_info2->rangelowers[cnt_parts];
+		PartitionRangeBound *upper1 = part_info1->rangeuppers[cnt_parts];
+		PartitionRangeBound *upper2 = part_info2->rangeuppers[cnt_parts];
+
+		if (!compare_partition_bounds(part_info1, lower1, lower2) ||
+			!compare_partition_bounds(part_info1, upper1, upper2))
+			return false;
+	}
+
+	/* Ok, everything matches. */
+	return true;
+}
+
+/*
+ * compare_partition_bounds
+ *
+ * Return true if given bound specifications match.
+ */
+static bool
+compare_partition_bounds(PartitionOptInfo *part_info,
+						 PartitionRangeBound *bound1,
+						 PartitionRangeBound *bound2)
+{
+	int		cnt_pks;
+	Datum  *val1 = bound1->val;
+	Datum  *val2 = bound2->val;
+
+	if (bound1->infinite != bound2->infinite ||
+		bound1->inclusive != bound2->inclusive	||
+		bound1->lower != bound2->lower)
+		return false;
+
+	/*
+	 * TODO:
+	 * Following part is common with compare_range_keys(), but that takes
+	 * PartitionKey as argument, which we don't have here.
+	 */
+	for (cnt_pks = 0; cnt_pks < part_info->partnatts; cnt_pks++)
+	{
+		Datum	cmpval;
+
+		cmpval = FunctionCall2Coll(&part_info->partsupfunc[cnt_pks],
+								   part_info->tcinfo->typcoll[cnt_pks],
+								   val1[cnt_pks], val2[cnt_pks]);
+
+		if (DatumGetInt32(cmpval))
+			return false;
+	}
+
+	/* Ok, everything matches. */
+	return true;
+}
+
+/*
+ * partkey_types_match
+ *
+ * Returns true if the partition key datatype and collation match for given
+ * partitioned relations. Returns false otherwise.
+ */
+static bool
+partkey_types_match(PartitionOptInfo *part_info1, PartitionOptInfo *part_info2)
+{
+	int		cnt_pks;
+	Oid	   *partopfamily1 = part_info1->partopfamily;
+	Oid	   *partopfamily2 = part_info2->partopfamily;
+	Oid	   *partopcintype1 = part_info1->partopcintype;
+	Oid	   *partopcintype2 = part_info2->partopcintype;
+	FmgrInfo *partsupfunc1 = part_info1->partsupfunc;
+	FmgrInfo *partsupfunc2 = part_info2->partsupfunc;
+	KeyTypeCollInfo *tcinfo1 = part_info1->tcinfo;
+	KeyTypeCollInfo *tcinfo2 = part_info2->tcinfo;
+
+	if (part_info1->partnatts != part_info1->partnatts)
+		return false;
+
+	for (cnt_pks = 0; cnt_pks < part_info1->partnatts; cnt_pks++)
+	{
+		/*
+		 * It suffices to check the OID of support function as it always has
+		 * two arguemnts and returns boolean. For types, it suffices to match
+		 * the type id, mod and collation; len, byval and align are depedent on
+		 * the first two.
+		 */
+		if (partopfamily1[cnt_pks] != partopfamily2[cnt_pks] ||
+			partopcintype1[cnt_pks] != partopcintype2[cnt_pks] ||
+			partsupfunc1[cnt_pks].fn_oid != partsupfunc2[cnt_pks].fn_oid ||
+			tcinfo1->typid[cnt_pks] != tcinfo2->typid[cnt_pks] ||
+			tcinfo1->typmod[cnt_pks] != tcinfo2->typmod[cnt_pks] ||
+			tcinfo1->typcoll[cnt_pks] != tcinfo2->typcoll[cnt_pks])
+			return false;
+	}
+
+	/* Everything matches. */
+	return true;
+}
diff --git a/src/backend/optimizer/plan/createplan.c b/src/backend/optimizer/plan/createplan.c
index 9e5b60e..6cd8d8c 100644
--- a/src/backend/optimizer/plan/createplan.c
+++ b/src/backend/optimizer/plan/createplan.c
@@ -339,20 +339,25 @@ create_plan(PlannerInfo *root, Path *best_path)
 
 /*
  * create_plan_recurse
  *	  Recursive guts of create_plan().
  */
 static Plan *
 create_plan_recurse(PlannerInfo *root, Path *best_path, int flags)
 {
 	Plan	   *plan;
 
+	/* TODO: remove this code to continue partition-wise join planning. */
+	if (best_path->parent->reloptkind == RELOPT_JOINREL &&
+		best_path->parent->part_info)
+		elog(ERROR, "the relation was considered for partition-wise join, which is not supported right now.");
+
 	switch (best_path->pathtype)
 	{
 		case T_SeqScan:
 		case T_SampleScan:
 		case T_IndexScan:
 		case T_IndexOnlyScan:
 		case T_BitmapHeapScan:
 		case T_TidScan:
 		case T_SubqueryScan:
 		case T_FunctionScan:
diff --git a/src/backend/optimizer/util/plancat.c b/src/backend/optimizer/util/plancat.c
index 95aca08..739ce3d 100644
--- a/src/backend/optimizer/util/plancat.c
+++ b/src/backend/optimizer/util/plancat.c
@@ -1202,21 +1202,28 @@ get_relation_constraints(PlannerInfo *root,
 					ntest->nulltesttype = IS_NOT_NULL;
 					ntest->argisrow = type_is_rowtype(att->atttypid);
 					ntest->location = -1;
 					result = lappend(result, ntest);
 				}
 			}
 		}
 	}
 
 	/* Append partition check quals, if any */
-	pcqual = RelationGetPartitionCheckQual(relation);
+	/*
+	 * TODO the copyObject wrapper has been added by me to avoid changing
+	 * partitioned copy of cache. This should be fixed by Amit in his original
+	 * patches and mostly in get_check_qual_for_range() or
+	 * get_relation_constraints(). Once it's fixed their, remove the copyObject
+	 * wrapper.
+	 */
+	pcqual = copyObject(RelationGetPartitionCheckQual(relation));
 	if (pcqual)
 	{
 		/* Fix Vars to have the desired varno */
 		if (varno != 1)
 			ChangeVarNodes((Node *) pcqual, 1, varno, 0);
 
 		result = list_concat(result, pcqual);
 	}
 
 	heap_close(relation, NoLock);
